﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_use_bit_operations
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int A = Convert.ToInt32("11111111000000001111111100000000", 2);
            int B = Convert.ToInt32("11111111111111110000000000000000", 2);
            txtA.Text = BinaryString(A, 32);
            txtB.Text = BinaryString(B, 32);

            Calculate();
        }

        private void btnCalculate_Click(object sender, EventArgs e)
        {
            Calculate();
        }

        // Perform the bitwise calculations.
        private void Calculate()
        {
            // Get A, B, and C.
            int A = Convert.ToInt32(txtA.Text, 2);
            int B = Convert.ToInt32(txtB.Text, 2);
            int C = int.Parse(txtC.Text);

            // Calculate and display results.
            // Not.
            int notA = ~A;
            txtNotA.Text = BinaryString(notA, 32);

            // A or B.
            int AorB = A | B;
            txtAorB.Text = BinaryString(AorB, 32);

            // A and B.
            int AandB = A & B;
            txtAandB.Text = BinaryString(AandB, 32);

            // A xor B.
            int AxorB = A ^ B;
            txtAxorB.Text = BinaryString(AxorB, 32);

            // A << C.
            int left_shift = A << C;
            txtLeftShift.Text = BinaryString(left_shift, 32);

            // A >> C.
            int right_shift = A >> C;
            txtRightShift.Text = BinaryString(right_shift, 32);
        }

        // Return a binary string representing the number,
        // padded with 0s on the left to the indicated number of bits.
        private string BinaryString(long value, int num_bits)
        {
            // Get the binary string.
            string result = Convert.ToString(value, 2);

            // Pad if necessary.
            result = result.PadLeft(num_bits, '0');

            // Trim to length if necessary.
            return result.Substring(result.Length - num_bits);
        }
    }
}
